<template>
  <div class="stretch">
    <div
      v-bind:id="'card-' + member.id"
      v-bind:key="member.id"
      class="card isRelative" draggable="true"
      @dragstart="drag">
      <DeleteMemberButton
        class="isAbsolute pullToUpperRightCorner"
        v-bind:index="index"
        v-bind:id="member.id"
        :method="removeMember"
        buttonText="X">
      </DeleteMemberButton>
      <NamePlate v-bind:member="member"></NamePlate>
    </div>
  </div>
</template>

<script>
import DeleteMemberButton from './DeleteMemberButton';
import NamePlate from './NamePlate';

export default {
  name: 'TeamMember',
  components: {
    DeleteMemberButton,
    NamePlate,
  },
  props: ['member', 'index'],
  methods: {
    drag(ev) {
      ev.dataTransfer.setData('text', ev.target.id);
    },
    removeMember(teamID, memberID) {
      const payload = {};
      payload.teamID = teamID;
      payload.memberID = memberID;
      this.$store.dispatch('removeMember', payload);
    },
  },
};
</script>

<style scoped>
  [draggable=true] {
    cursor: -webkit-grab;
  }
  .isRelative {
    position: relative;
  }
  .isAbsolute {
    position: absolute;
  }
  .pullToUpperRightCorner {
    top: 5px;
    right: 5px;
  }
  .stretch {
    width: 100%;
  }
  .card {
    display: block;
    width: 100%;
    height: 50px;
    border-radius: 5px;
    border-color: grey;
    background-color: rgba(0, 0, 0, 0.2);
  }
  .card:not(:last-child) {
    margin-bottom: 5px;
  }
</style>
